unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TPlu=record
     Name:         PChar;
     LFCode:       Longint;
     Code:         PChar;
     BarCode:      Longint;
     UnitPrice:    Longint;
     WeightUnit:   Longint;
     Deptment:     Longint;
     Tare:         Double;
     ShlefTime:    Longint;
     PackageType:  Longint;
     PackageWeight:Double;
     Tolerance:    Longint;
     Message1:     Byte;
     Reserved:     Byte;
     Reserved1:    Word;
     Message2:     Byte;
     Reserved2:    Byte;
     MultiLabel:   Byte;
     Rebate:       ShortInt;
     Account:      LongInt;
   end;
  PPLU=^TPLU;
  TPLUCluster=Array[0..3]of TPLU;
  PPLUCluster=^TPLUCluster;
  THotkeyTable=Array[0..83]of LongInt;
  PHotkeyTable=^THotkeyTable;

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Label1: TLabel;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PLUCluster:TPLUCluster;
  HotKeyTable:THotKeyTable;
  Str:Array[0..255]of Char;
  PLU:TPLU;
  PLUName:Array[0..255]of Char;
  PLUCode:Array[0..255]of Char;
  Function PBusConnect(RefLFZKFileName:PChar;
                       RefCFGFileName:PChar;
                       SerialNO:DWord;
                       CommName:PChar;
                       BaudRate:Integer
                       ):Integer;Stdcall;far; external 'PBusDrv.dll';
  Function PBusDisConnect(SerialNO:DWord):Integer;Stdcall;far; external 'PBusDrv.dll';
  Function PBusTransferPLUCluster(PPC:PPLUCluster):Integer;Stdcall;far; external 'PBusDrv.dll';
  Function PBusTransferHotkey(HotkeyTable:PHotkeyTable;
                              TableIndex:Integer
                              ):Integer;Stdcall;far; external 'PBusDrv.dll';
  Function PBusPLUToStr(LPPLU:PPLU;LPStr:PChar):Integer;Stdcall;far; external 'PBusDrv.dll';
  Function PBusStrToPLU(LPStr:PChar;LPPLU:PPLU):Integer;Stdcall;far; external 'PBusDrv.dll';
  Function PBusConnectEx(RefLFZKFileName:PChar;
                       RefCFGFileName:PChar;
                       IPAddr:PChar
                       ):Integer;Stdcall;far; external 'PBusDrv.dll';
  Function PBusDisConnectEx(IPAddr:PChar):Integer;Stdcall;far; external 'PBusDrv.dll';

implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
Var
  Result:Integer;
  I,J:Longint;
  PLUNames:Array[0..3]of string;
  PLUCodes:Array[0..3]of string;
begin
  {Connect}
  Result:=PBusConnectEx('.\lfzk.dat','.\system.cfg','192.168.0.198');
  if(Result<0) then exit;
  {Init}
  for J:=0 to 500 do
  begin
    FillChar(PLUCluSter,sizeof(TPLUCluSter),0);
    for I:=0 to 3 do
    begin
      FillChar(PLU,sizeof(TPLU),0);
      PLUNames[I]:='Ǵײ'+IntToStr(J*4+I);
      PLU.Name:=PChar(PLUNames[I]);
      PLU.LFCode:=J*4+I+1+20000;
      PLUCodes[I]:='6'+IntToStr(J*4+I);
      PLU.Code:=PChar(PLUCodes[I]);
      PLU.WeightUnit:=4;
      PLU.ShlefTime:=15;
      PLU.Deptment:=2;
      PLU.BarCode:=40;
      PLU.UnitPrice:=8888888;
      PLU.ShlefTime:=15;
      PLUCluSter[I]:=PLU;
    end;
    {Transfer one PLU}
    Label1.Caption:=IntToStr(J*4);
    Label1.Refresh;
    Result:=PBusTransferPLUCluster(@PLUCluSter);
    if(Result<0) then exit;
  end;
  FillChar(HotKeyTable,sizeof(THotKeyTable),0);
  HotkeyTable[0]:=12340;
  HotkeyTable[1]:=12341;
  {Test PLUToStr}
  FillChar(Str,256,0);
  PBusPLUToStr(@PLU,@Str);
  {Test StrToPLU}
  FillChar(PLU,sizeof(TPLU),0);
  PLU.Name:=@PLUName;
  PLU.Code:=@PLUCode;
  PBusStrToPLU(@Str,@PLU);
  {Transfer Hotkey}
  Result:=PBusTransferHotkey(@HotKeyTable,0);
  {DisConnect}
  //Result:=PBusDisConnect(1234); //ʹʵʵĳӺ
  Result:=PBusDisConnectEx('192.168.0.198');
  ShowMessage('Test OK');
end;

end.
